
import numpy
import time
from multiprocessing import Pool
import numpy 

"""
Some code to test multiprocessing code with a pool of workers to compute the
sum of the elements in a matrix. 
"""

numpy.random.seed(21)
numRows = 10000
numCols = 500
X = numpy.random.rand(numRows, numCols)
repetitions = 10

def f(inds):
    for i in range(repetitions):
        tempSum = numpy.sum(X[inds, :]**2)
    return tempSum

stepSize = 2000
paramList = []
for i in range(numRows/stepSize):
    paramList.append(range(i*stepSize, (i+1)*stepSize))

#Serial version 
start = time.time()
sum1 = 0 
for params in paramList:
    sum1 += f(params)
totalTime = time.time() - start
print(sum1)
print(totalTime)

#Parallel version
pool = Pool(processes=2)              # start 2 worker processes
start = time.time()
it = pool.imap(f, paramList)

pool.close()
pool.join()

sum2 = 0
for val in it: 
    sum2 += val

totalTime = time.time() - start

print(sum2)
print(totalTime)

#How do we pass in multiple parameters? - pass in tuple 
